/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "chunk.h"

void chunkCreate(chunk_t *chunk) {
  int32_t count, x, y, i;

  count = CHUNK_WIDTH * CHUNK_HEIGHT * CHUNK_DEPTH;
  chunk->batch = spriteBatchCreate(count);
  chunk->tiles = malloc(sizeof(tile_t) * count);
}

void chunkRender(chunk_t *chunk, shader_t *shader) {
  // Coordinates of the chunk.
  float x, y, z;
  x = (chunk->x * CHUNK_WIDTH);
  y = (chunk->y * CHUNK_HEIGHT);
  z = (chunk->z * CHUNK_DEPTH);

  // Render the batch.
  shaderUsePosition(shader, x, y, z, 0, 0, 0);
  spriteBatchDraw(chunk->batch, 0, -1);
}

void chunkLoad(chunk_t *chunk, int32_t x, int32_t y, int32_t z) {
  int32_t tx, ty, tz;

  spriteBatchFlush(chunk->batch);

  // for(tx = 0; tx < CHUNK_WIDTH; tx++) {
  //   for(ty = 0; ty < CHUNK_HEIGHT; ty++) {
  //     for(tz = 0; tz < CHUNK_DEPTH; tz++) {
  //       spriteBatchQuad(chunk->batch, -1,
  //         x, y, z, 1, 1, 0, 0, 1, 1
  //       );
  //     }
  //   }
  // }
}

void chunkUnload(chunk_t *chunk) {
  
}